﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Newtonsoft.Json.Linq;
using System.Net;
using System.IO;
using Newtonsoft.Json;

namespace MC_Launcher_v2.Business.Minecraft.Net
{
    public static class Request
    {
        public static T Post<T>(string url, JObject obj)
        {
            return (T)JsonConvert.DeserializeObject(Post(url, obj), typeof(T));
        }

        public static string Post(string url, JObject obj)
        {
            byte[] data = Encoding.UTF8.GetBytes(obj.ToString());
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            req.Method = "POST";
            req.ContentType = "application/json";
            req.ContentLength = data.Length;

            var str = req.GetRequestStream();
            str.Write(data, 0, data.Length);
            str.Close();

            string content = "";
            var resp = (HttpWebResponse)req.GetResponse();
            if (resp.StatusCode == HttpStatusCode.NoContent)
                return content;

            str = resp.GetResponseStream();
            using (StreamReader reader = new StreamReader(str))
                content = reader.ReadToEnd();

            str.Close();
            resp.Close();

            return content;
        }

        public static bool SimplePost(string url, JObject obj)
        {
            return Post(url, obj).Length == 0;
        }
    }
}
