﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace MC_Launcher_v2.Business.Minecraft.Profiles
{
    public class JavaProfile
    {
        #region VARIABLES
        public static int MAX_MEMORY = (int)(new Microsoft.VisualBasic.Devices.ComputerInfo().TotalPhysicalMemory / 1024UL / 1024UL);
        private int ram;
        #endregion

        #region PROPERTIES
        public string Executable { get; set; }
        public string Args { get; set; }
        public int Ram
        {
            get { return ram; }
            set
            {
                if (ram != value)
                {
                    if (value <= MAX_MEMORY)
                        ram = value;
                }
            }
        }
        public string Name { get; set; }
        public string Version { get; set; }
        public string LibVersion { get; set; }
        public bool Active { get; set; }
        #endregion

        #region CONSTRUCTORS
        public JavaProfile()
        {
            ram = MAX_MEMORY / 2;
            Executable = GetJavaPath();
            Active = false;
            Version = "1";
            LibVersion = "1";
            Args = "-XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn128M";
            Name = "Neues Profil";
        }
        #endregion

        public override string ToString()
        {
            return Name;
        }

        public static string GetJavaPath()
        {
            try
            {
                var key = Registry.LocalMachine.OpenSubKey("SOFTWARE\\JavaSoft\\Java Runtime Environment");
                string version = (string)key.GetValue("CurrentVersion", "");
                if (!string.IsNullOrEmpty(version))
                {
                    key = key.OpenSubKey(version);
                    string path = (string)key.GetValue("JavaHome");
                    if (File.Exists(path + "\\bin\\javaw.exe"))
                        return path + "\\bin\\javaw.exe";
                }
            }
            catch { }
            return "";
        }
    }
}
