﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace MC_Launcher_v2.Business
{
    public static class SimpleJsonFile
    {
        public static T FromFile<T>(string path) where T : new()
        {
            if (!File.Exists(path))
                return new T();
            string content = "";
            using (StreamReader reader = new StreamReader(path))
                content = reader.ReadToEnd();

            return (T)JsonConvert.DeserializeObject(content, typeof(T));
        }

        public static void SaveToFile(string path, object T)
        {
            string content = JsonConvert.SerializeObject(T, Formatting.Indented);
            using (StreamWriter writer = new StreamWriter(path))
                writer.Write(content);
        }
    }
}
