﻿using MC_Launcher_v2.Business;
using MC_Launcher_v2.Business.Minecraft;
using MC_Launcher_v2.Business.Minecraft.Net;
using MC_Launcher_v2.Business.Minecraft.Profiles;
using MC_Launcher_v2.FTP;
using MC_Launcher_v2.Presentation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows.Forms;

namespace MC_Launcher_v2
{
    public static class Launcher
    {
        #region PROPERTIES
        public static List<JavaProfile> JavaProfiles { get; set; }
        public static List<Business.Minecraft.Profiles.UserProfile> UserProfiles { get; set; }
        public static Business.Minecraft.Profiles.UserProfile SelectedUserProfile { get; set; }
        public static FtpManager FtpManager { get; set; }
        public static frmMain MainForm { get; set; }
        #endregion

        #region METHODS
        public static void Run(string[] args)
        {
            JavaProfiles = new List<JavaProfile>();
            UserProfiles = new List<Business.Minecraft.Profiles.UserProfile>();
            FtpManager = new FtpManager(FtpSettings.FromFile("ftp_settings.json"));

            LoadJavaProfiles();
            LoadUserProfiles();
            MainForm = new frmMain();
            Application.Run(MainForm);
        }

        public static void LoadJavaProfiles()
        {
            try
            {
                JavaProfiles.Clear();
                JavaProfiles = SimpleJsonFile.FromFile<List<JavaProfile>>("profiles_java.json");
                if (JavaProfiles.Count == 0)
                    JavaProfiles.Add(new JavaProfile() { Name = "Automatisch generiertes Profil" });
            }
            catch { }
        }

        public static void LoadUserProfiles()
        {
            try
            {
                UserProfiles.Clear();
                UserProfiles = SimpleJsonFile.FromFile<List<Business.Minecraft.Profiles.UserProfile>>("profiles_users.json");
            }
            catch { }
        }

        public static void SaveJavaProfiles()
        {
            SimpleJsonFile.SaveToFile("profiles_java.json", JavaProfiles.ToArray());
        }

        public static void SaveUserProfiles()
        {
            SimpleJsonFile.SaveToFile("profiles_users.json", UserProfiles.ToArray());
        }
        #endregion
    }
}
