﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MetroFramework.Controls;
using MetroFramework.Drawing;
using MetroFramework.Components;

namespace MC_Launcher_v2.Presentation
{
    public partial class MetroListView : ListView
    {
        public MetroListView()
        {
            InitializeComponent();
            this.FullRowSelect = true;
            this.DoubleBuffered = true;
            this.View = View.Details;
            this.OwnerDraw = true;
            this.DrawColumnHeader += MetroListView_DrawColumnHeader;
            this.DrawItem += (s, e) => e.DrawDefault = true;
            this.DrawSubItem += (s, e) => e.DrawDefault = true;
            this.BackColor = Color.FromArgb(17, 17, 17);
            this.ForeColor = Color.FromArgb(170, 170, 170);
        }

        static Color COLUMN_HEADER_BG = Color.FromArgb(34, 34, 34);
        static Color COLUMN_HEADER_FG = Color.FromArgb(204, 204, 178);
        static Color COLUMN_HEADER_BR = Color.FromArgb(68, 68, 68);

        private void MetroListView_DrawColumnHeader(object sender, DrawListViewColumnHeaderEventArgs e)
        {
            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

            using (SolidBrush brush = new SolidBrush(COLUMN_HEADER_BG))
                e.Graphics.FillRectangle(brush, e.Bounds);

            using (Pen p = new Pen(COLUMN_HEADER_BR))
            {
                e.Graphics.DrawLine(p,
                    e.Bounds.X, e.Bounds.Y,
                    e.Bounds.X, e.Bounds.Bottom);

                e.Graphics.DrawLine(p,
                    e.Bounds.Right - 1, 0,
                    e.Bounds.Right - 1, e.Bounds.Bottom);

                e.Graphics.DrawLine(p,
                    0, 0,
                    e.Bounds.Right, 0);

                e.Graphics.DrawLine(p,
                    0, e.Bounds.Bottom - 1,
                    e.Bounds.Right, e.Bounds.Bottom - 1);
            }
            using (StringFormat format = new StringFormat())
            {
                format.Alignment = StringAlignment.Center;
                format.LineAlignment = StringAlignment.Center;
                format.Trimming = StringTrimming.EllipsisCharacter;
                format.FormatFlags = StringFormatFlags.LineLimit;

                using (Brush bg = new SolidBrush(COLUMN_HEADER_FG))
                    e.Graphics.DrawString(e.Header.Text, this.Font, bg, e.Bounds, format);
            }
        }
    }
}
